/*
  what do you thing this class does? hm. If its name "volumefilter"
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <filter/volumeFilter.h>


VolumeFilter::VolumeFilter() {
  
}


VolumeFilter::~VolumeFilter() {
}

void VolumeFilter::transform(DeviceConfig* config) {
  
  AudioBuffer* audioBuffer;
  YafAudioInfo* audioInfo;
  MemChunk* memChunk;
  char* ptr;

  int j;
  int len;
  float volume;


  audioBuffer=config->getAudioBuffer();
  memChunk=audioBuffer->getMemChunk();
  ptr=memChunk->getPtr();

  audioInfo=config->getAudioInfo();
  volume=audioInfo->getVolume();
  volume=volume/100.0;
  len=memChunk->getLen();

  for (j=0;j<len;j++) {
    ptr[j]=(int)(volume*(float)ptr[j]);
  }
}


void VolumeFilter::transform(DeviceConfigArray* input,DeviceConfig* output) {
  DeviceConfig* config;
  AudioBuffer* audioBuffer;
  YafAudioInfo* audioInfo;
  MemChunk* memChunk;
  MemChunk* pcmChunk;
  char* ptr;
  int maxLen;
  int i;
  int j;
  float volSum;
  float volume;
  int elements = input->getEntries();



  audioBuffer=output->getAudioBuffer();
  pcmChunk=audioBuffer->getMemChunk();
  
  // select an arbitary audioConfiguration...
  // the user must take care that they are all the same
  // (because this device cannot convert eg. 22,5KHz to eg. 44,1KHz)
  config=input->getDeviceConfigAt(0);

  // this overrides the pcmChunk!
  config->copyTo(output);
 


  maxLen=input->getMaximumMemChunkLen();
  volSum=input->getVolumeSum();

  if (maxLen > _MAX_MIX_SIZE) {
    maxLen=_MAX_MIX_SIZE;
    cout << "maximum mixer length too short! skipping bytes!"<<endl;
  }
  if (maxLen > pcmChunk->getSize()) {
    maxLen=pcmChunk->getSize();
    cout << "maximum memChunk length too short! skipping bytes!"<<endl;
  }

	

  for(i=0;i<elements;i++) {
    config=input->getDeviceConfigAt(i);
    audioBuffer=config->getAudioBuffer();
    memChunk=audioBuffer->getMemChunk();
    ptr=memChunk->getPtr();
    audioInfo=config->getAudioInfo();
    volume=audioInfo->getVolume();
    volume=volume/volSum;


    // speed optimisation. If volume is 0 we dont need to add
    // but we must make sure that we at least call the add
    // routine one! (i>0)
    if ((volume == 0) && (i > 0)) {
      continue;
    }
    for (j=0;j<maxLen;j++) {
      if (i == 0) {
	mixArray[j]=0.0;
      }
      if ((memChunk->getLen() < j) && (i > 0)) {
	break;
      }
      mixArray[j]+=volume*(float)ptr[j];
    }
  }



  
  audioBuffer=output->getAudioBuffer();
  audioBuffer->setMemChunk(pcmChunk);
  pcmChunk->setLen(maxLen);
  ptr=pcmChunk->getPtr();

  for (j=0;j<maxLen;j++) {
    ptr[j]=(char)mixArray[j];
  }
  
  

}
  

